Maratis
=======

Maratis is a portable, simple and visual game development tool designed for 
artists and developers. The Engine has been tested on Windows, Mac, Linux and 
iOS and can be used virtually on any platform.

Use a simple Lua scripting langage or have access to the full engine in C++ 
via the SDK.

Maratis is originally created by Anaël Seghezzi and is Free and Open-Source.

http://maratis3d.org

Compilation
-----------

This version uses LuaJIT as the standard LUA solution.
You can compile the engine to use Lua instead of LuaJIT by using

-DSTANDARD_LUA=true

when calling cmake.

Features
--------

- Editor based environment
- Light and powerful Engine (MCore + MEngine), portable, both previous and 
  next generation (Fixed pipeline and Shader based pipeline)
- Per pixel lightning, custom shaders (glsl), normal map, dynamic shadows, 
  animated meshs…
- Blender exporter, native mesh format with animation (materials, textures, 
  shaders, armatures)
- 3D formats import (Collada, obj, md3…) through Assimp
- Multilayered uvMaps (custom multitexture, baked light map, etc)
- Bullet physics, 3D sound, Font system (can load TTF)
- Standard image and sound format (TGA, JPG, PNG, WAV, AIF, OGG…)
- Lua scripting language
- C++ SDK


License
-------

Maratis is a free and open source game development environment.

- Maratis Engine is licensed under the zlib/libpng License
- Maratis Editor « Maratis » is licensed under the GNU General Public License


Contact
-------

Anaël Seghezzi, France
anael (a) maratis3d.com
